<? include("std.inc"); ?>
<? include("header.inc"); ?>
<? include("docs.inc"); ?>

<?
func_title("bg_image");
args("file", "filename", "Image filename to display");
args(-1);

?>

Displays an image in the background of a table cell or other HTML element.
This function replaces the <i>background=""</i> parameter to HTML tags,
but only for images which are stored on the local server.  To display images
stored on other sites, use the regular HTML tags instead.
<p>
You would normally do this:
<pre>
  &lt;td background="gfx/foo.jpg"&gt; Hi. &lt;/td&gt;
</pre>
But doing it this way adds inheritance:
<pre>
  &lt;td &lt;? bg_image("foo.jpg"); ?&gt;&gt; Hi. &lt;/td&gt;
</pre>
<p>

<? include("footer.inc"); ?>
