<? include("std.inc"); ?>
<? include("header.inc"); ?>
<? include("docs.inc"); ?>

<?
func_title("page");
args("file", "filename", "Page filename to link to");
args("text", "text", "Text to display in the link", 0, "", "filename");
args(-1);

?>

Links to another page.  
This function replaces the &lt;a href="foo.html"&gt; tag,
but only for pages which are stored on the local server.  
To link to pages stored on other sites, use the regular HTML tags instead.
<p>
page() provides inheritance.  It searches parent directories
to find the page you ask for.
<p>
If the page is not found, the link will be ignored.  An error will
be inserted into an HTML comment, to let you know it failed.

<p>
  
Example:

<table border=1 width="100%">
  <tr><td width="50%">Code</td><td width="50%">Result</td></tr>
  <tr><td width="50%" valign=top>
<pre>
&lt;?
  page("doc/", "Bering Sea.com Documentation"); 
?&gt;
</pre>
  </td>
  <td width="50%">
<? 
  page("doc/", "Bering Sea.com Documentation"); 
?>
  </td></tr>
</table>

<? include("footer.inc"); ?>
