<?
include_once("curve_box.inc");

function func_title($name)
{
   curve_box_top();
   printf("Function: %s()\n", $name);
   curve_box_bottom();
}

function args($name="", $type="text", $note="", $req=1, $values="", $def="")
{
   if(!$name)
   {
      printf("<b>Parameters:</b> None<br>\n");
      printf("<hr noshade>\n");
   }
   elseif($name == -1)
   {
      printf("<hr noshade>\n");
   }
   else
   {
      $reqtext = "(Required)";
      if(!$req) $reqtext = "(Optional)";
      
      printf("<table>\n");
      printf("<tr><td><b>Parameter:</b></td><td>%s %s</td></tr>\n", 
	     $name, $reqtext);
      printf("<tr><td><b>Type:</b></td><td>%s</td></tr>\n", $type);
      if($def != "")
      {
         printf("<tr><td><b>Default Value:</b></td><td>%s</td></tr>\n", $def);
      }
      if($values != "")
      {
         printf("<tr><td><b>Range:</b></td><td>%s</td></tr>\n", $values);
      }
      if($note != "")
      {
         printf("<tr><td><b>Notes:</b></td><td>%s</td></tr>\n", $note);
      }
      printf("</table>\n");
      printf("<p>\n");
   }
}

?>
