<? include("std.inc"); ?>
<? $title = "{$site_name} User Administration"; ?>
<? include_once("edit/php/custom.inc"); ?>
<? include("header.inc"); ?>

<?

function user_permission_form($u)
{
   blurb("File Edit Permissions");
   // User access lists

   $num_perms = edit_check_perm(&$u);
   if($num_perms <= 0)
   {
      printf("No permissions!  (%s)<br>\n", $num_perms);
   }

   $form_action = "{$SCRIPT_URL}?action=edit_user_permission_submit";
   printf("<form method=post action=\"%s\">\n", $form_action);
   printf("<input type=hidden name=\"uid\" value=\"%s\">\n", $u->UID);

   printf("<table>\n");
   printf("<tr><td>Delete?</td>" .
	  "<td>Path</td>" .
	  "<td>Allow</td>" .
	  "<td>Type</td></tr>\n");
   $i = 0;
   foreach($u->perm as $p)
   {
      printf("<tr><td><input type=checkbox name=\"perm_del:%s\" /></td>",
	     $i);
      printf("<td>%s</td><td>%s</td><td>%s</td></tr>\n",
	     $p->target, $p->status, $p->type);
      $i ++;
   }
   printf("</table>\n");

   printf("<table><tr>\n");
   printf("<td>Add new permission:</td>\n");
   printf("<td><input type=text name=perm_path></td>\n");
   printf("<td><select name=perm_allow>\n");
   printf("<option value=none>Allow?</option>\n");
   printf("<option value=enable>enable</option>\n");
   printf("<option value=disable>disable</option>\n");
   printf("</select></td>\n");
   printf("<td><select name=perm_type>\n");
   printf("<option value=none>Type</option>\n");
   printf("<option value=read>read</option>\n");
   printf("<option value=write>write</option>\n");
   printf("</select></td>\n");
   printf("</tr></table>\n");
   

   echo "<input type=submit value=\"Go\">\n";
   echo "<input type=reset value=\"Nevermind...\">\n";

   printf("</form>\n");
   eb();
}

function set_user_permission($auth_user)
{
   // Values to set: "setvar:" username, realname, password, password2
   global $HTTP_POST_VARS;

   $db = connect_db();

   $uid = $HTTP_POST_VARS["uid"];
   if($uid <= 0)
   {
      printf("Invalid user ID.<br>\n");
      return;
   }

   $u = create_user_from_db($uid);
   if(! $u) return;

   $num_perms = edit_check_perm(&$u);
   if($num_perms <= 0)
   {
      printf("No permissions!  (%s)<br>\n", $num_perms);
   }

   // TODO: collect a list of permissions to delete
   $searchtext = "perm_del:";
   $searchlen = strlen($searchtext);
   $del_perms = array();
   foreach ($HTTP_POST_VARS as $k => $v)
   {
      if (substr($k, 0, $searchlen) == $searchtext)
      {
	 $index = substr($k, $searchlen);
	 $index = intval($index);
	 //printf("Delete permission: #%s<br>\n", $index);
	 $del_perms[$index] = 1;
      }
   }
   // TODO: delete permissions
   $i = 0;
   foreach ($u->perm as $p)
   {
      if ($del_perms[$i])
      {
	 printf("Deleting permission: %s %s %s<br>\n",
		$p->path, $p->status, $p->type);
	 // remove permission from database
	 $query = sprintf("DELETE FROM permission ".
			  "WHERE UID=%s ".
			  "AND target='%s' " .
			  "AND type='%s' " .
			  "AND status='%s';",
			  $u->UID, $p->target, $p->type, $p->status);
	 //printf("Q: %s<br>\n", $query);
	 unset($u->perm[$i]);
	 mysql_query($query);
      }
      $i ++;
   }

   // TODO: create new permissions
   $p_path = $HTTP_POST_VARS["perm_path"];
   $p_allow = $HTTP_POST_VARS["perm_allow"];
   $p_type = $HTTP_POST_VARS["perm_type"];

   if($p_path)
   {
      printf("Adding permission...\n");
      if(in_array($p_allow, array("enable", "disable")))
      {
	 if(in_array($p_type, array("read", "write")))
	 {
	    printf("%s %s %s<br>\n",
		   $p_path, $p_allow, $p_type);
	    $query = sprintf("INSERT INTO permission VALUES " .
			     "(%s, '%s', '%s', '%s');",
			     $u->UID, $p_path, $p_type, $p_allow);
	    mysql_query($query);
	 }
	 else printf("Invalid permission type.<br>\n");
      }
      else printf("Invalid permission status.<br>\n");
   }
   

   printf("Changes saved.<br>\n");

   printf("<a href=\"{$SCRIPT_URL}?action=edit_user&uid=%s\">" .
	  "Back to user info</a>\n",
	  $u->UID);
}

function user_basic_form($u)
{
	 blurb("Basic User Info");
   $form_action = "{$SCRIPT_URL}?action=edit_user_basic_submit";
   printf("<form method=post action=\"%s\">\n", $form_action);
   printf("<input type=hidden name=\"uid\" value=\"%s\">\n", $u->UID);
   
   // Regular user info
   // UID, username, passwd, realname
   printf("<table>\n");

   printf("<tr><td align=right>%s</td>\n", "User Name");
   printf("<td>\n<input type=text name=\"setvar:%s\" value=\"%s\">\n",
	  "username", $u->username);
   echo "</td></tr>\n";
   
   printf("<tr><td align=right>%s</td>\n", "Real Name");
   printf("<td>\n<input type=text name=\"setvar:%s\" value=\"%s\">\n",
	  "realname", $u->realname);
   echo "</td></tr>\n";
   
   printf("<tr><td align=right>%s</td>\n", "Email");
   printf("<td>\n<input type=text name=\"setvar:%s\" value=\"%s\">\n",
	  "email", $u->email);
   echo "</td></tr>\n";
   
   printf("<tr><td align=right>%s</td>\n", "Password");
   printf("<td>\n<input type=password name=\"setvar:%s\" value=\"%s\">\n",
	  "password", "");
   echo "</td></tr>\n";
   
   printf("<tr><td align=right>%s</td>\n", "Password (Again)");
   printf("<td>\n<input type=password name=\"setvar:%s\" value=\"%s\">\n",
	  "password2", "");
   echo "</td></tr>\n";
   
   printf("</table>\n");

   echo "<input type=submit value=\"Go\">\n";
   echo "<input type=reset value=\"Nevermind...\">\n";
   
   echo "</form>\n";
	 eb();
}

function set_user_basic($auth_user)
{
   // Values to set: "setvar:" username, realname, password, password2
   global $HTTP_POST_VARS;

   $db = connect_db();

   $uid = $HTTP_POST_VARS["uid"];
   if($uid <= 0)
   {
      printf("Invalid user ID.<br>\n");
      return;
   }

   $u = create_user_from_db($uid);
   if(! $u) return;
   
   $table = "user";

   $var = "setvar:username";
   $field = "user";
   $orig = $u->username;
   $value = $HTTP_POST_VARS[$var];
   if($value  and  ($value != $orig))
   {
      printf("%s...<br>\n", $field);
      $query = "update $table set $field = '$value' where ID = $uid;";
      mysql_query($query);
   }

   $var = "setvar:realname";
   $field = "name";
   $orig = $u->realname;
   $value = $HTTP_POST_VARS[$var];
   if($value  and  ($value != $orig))
   {
      printf("%s...<br>\n", $field);
      $query = "update $table set $field = '$value' where ID = $uid;";
      mysql_query($query);
   }

   $var = "setvar:email";
   $field = "email";
   $orig = $u->email;
   $value = $HTTP_POST_VARS[$var];
   if($value  and  ($value != $orig))
   {
      printf("%s...<br>\n", $field);
      $query = "update $table set $field = '$value' where ID = $uid;";
      mysql_query($query);
   }
   
   $var = "setvar:password";
   $var2 = "setvar:password2";
   $field = "passwd";
   $pass1 = $HTTP_POST_VARS[$var];
   $pass2 = $HTTP_POST_VARS[$var2];
   $value = "'$pass1'";
   if($pass1  and  ($pass1 == $pass2))
   {
      printf("%s...<br>\n", $field);
      $query = "update $table set $field = $value where ID = $uid;";
      mysql_query($query);
   }

   printf("Values have been updated.<br>\n");

   printf("<a href=\"{$SCRIPT_URL}?action=edit_user&uid=%s\">" .
	  "Back to user info</a>\n",
	  $u->UID);
}

function user_group_form($u)
{
   blurb("User Groups");
   $form_action = "{$SCRIPT_URL}?action=edit_user_group_submit";
   printf("<form method=post action=\"%s\">\n", $form_action);
   printf("<input type=hidden name=\"uid\" value=\"%s\">\n", $u->UID);

   // Get a grouplist
   $groups = load_all_groups();
   
   // User Groups...
   echo "<table>\n";
   foreach ($groups as $g)
   {
      //$gid = $g->ID;
      //$group = $g->name;
      
      printf("<tr><td align=right valign=top>%s</td>\n",
	     $g->name);
      $check_name = sprintf("enablegroup:%s", $g->ID);
      $checked = "";
      if(in_array($g->name, $u->groups))  $checked = "checked";
      printf("<td><input type=checkbox name=\"%s\" %s></td>\n",
	     $check_name, $checked);
      printf("<td valign=top>%s</td>\n", $g->desc);
      printf("</tr>\n");
   }
   echo "</table>\n";
   
   echo "<input type=submit value=\"Go\">\n";
   echo "<input type=reset value=\"Nevermind...\">\n";
   
   echo "</form>\n";
   eb();
}

function set_user_group($auth_user)
{
   global $HTTP_POST_VARS;

   $lstrip = "enablegroup:";
   $lstriplen = strlen($lstrip);

   $db = connect_db();

   $uid = $HTTP_POST_VARS["uid"];
   if($uid <= 0)
   {
      printf("Invalid user ID.<br>\n");
      return;
   }

   $u = create_user_from_db($uid);
   if(! $u) return;
   $u->load_groups();
   
   // Get a grouplist
   $groups = load_all_groups();
   

   $gidlist = array();
   
   foreach($HTTP_POST_VARS as $key => $value)
   {
      if(substr($key, 0, $lstriplen) == $lstrip)
      {
	 $gid = substr($key, $lstriplen);
	 $gname = $groups[$gid]->name;
	 $gidlist[$gid] = $gname;
      }
   }

   $table = "groupdb";

   $delquery = "delete from $table where UID = $uid;";
   mysql_query($delquery);

   foreach($gidlist as $gid => $gname)
   {
      printf("%s...<br>\n", $gname);
      $query = "insert into $table values ($gid, $uid);";
      mysql_query($query);
   }

   printf("Values have been updated.<br>\n");

   printf("<a href=\"{$SCRIPT_URL}?action=edit_user&uid=%s\">" .
	  "Back to user info</a>\n",
	  $u->UID);
}

function user_hash_form($u)
{
   blurb("Misc User Options");
   $form_action = "{$SCRIPT_URL}?action=edit_user_hash_submit";
   printf("<form method=post action=\"%s\">\n", $form_action);
   printf("<input type=hidden name=\"uid\" value=\"%s\">\n", $u->UID);

   // User hash options
   echo "<table>\n";
   foreach ($u->attribs as $a)
   {
      $name = $a->key;
      $value = $a->value;
      $edit = $a->edit;

      //printf("edit: %s<br>\n", $edit);
      
      $on = "";
      if($edit) { $on = "checked"; }
      
      //$fixedname = str_replace(" ", "%20", $name);
      $fixedname = trans_var($name);
      echo "<tr>\n";
      printf("<td><input type=checkbox name=\"editvar:%s\" %s>Editable</td>\n",
	     $fixedname, $on);
      printf("<td align=right>%s</td>\n", $name);
      printf("<td><input type=text name=\"setvar:%s\" value=\"%s\">" .
	     "</td>\n",
	     $fixedname, $value);
      printf("<td><input type=checkbox name=\"delvar:%s\">Delete</td></tr>\n",
	     $fixedname);
   }
   echo "<tr>\n";
   printf("<td><input type=checkbox name=\"addvar:edit\">Editable</td>\n");
   printf("<td align=right><input type=text name=\"addvar:name\"></td>\n");
   printf("<td><input type=text name=\"addvar:value\"></td>\n");
   printf("<td><i><b>Add New...</b></i></td></tr>\n");
   echo "</table>\n";

   echo "<input type=submit value=\"Go\">\n";
   echo "<input type=reset value=\"Nevermind...\">\n";
   
   echo "</form>\n";
}

function set_user_hash($auth_user)
{
   // Values to set: "setvar:" username, realname, password, password2
   global $HTTP_POST_VARS;

   trans_post_vars();

   $db = connect_db();
   
   $uid = $HTTP_POST_VARS["uid"];
   if($uid <= 0)
   {
      printf("Invalid user ID.<br>\n");
      return;
   }

   $u = create_user_from_db($uid);
   if(! $u) return;
   
   $table = "user_hash";


   // Get a complete list of hash variables
   $lstrip = "setvar:";
   $lstriplen = strlen($lstrip);

   $hashlist = array();
   foreach($HTTP_POST_VARS as $key => $value)
   {
      if(substr($key, 0, $lstriplen) == $lstrip)
      {
	 $hashvar = substr($key, $lstriplen);
	 $hashvar = str_replace("%20", " ", $hashvar);
	 $hashval = $value;
	 $a = user_attribute($hashvar, $hashval, 0);
	 //printf("setvar: %s => %s<br>\n", $hashvar, $hashval);
	 $hashlist[$hashvar] = $a;
      }
   }

   // Figure out which ones are editable
   $lstrip = "editvar:";
   $lstriplen = strlen($lstrip);

   foreach($HTTP_POST_VARS as $key => $value)
   {
      if(substr($key, 0, $lstriplen) == $lstrip)
      {
	 $hashvar = substr($key, $lstriplen);
	 $hashvar = str_replace("%20", " ", $hashvar);
	 $editval = $value;
	 if ($editval == "on") {$editval = 1;}
	 else {$editval = 0; }
	 //printf("editvar: %s => %s<br>\n", $hashvar, $editval);
	 $hashlist[$hashvar]->edit = $editval;
      }
   }
   
   // Figure out which variables to delete
   $lstrip = "delvar:";
   $lstriplen = strlen($lstrip);

   $dellist = array();
   foreach($HTTP_POST_VARS as $key => $value)
   {
      if(substr($key, 0, $lstriplen) == $lstrip)
      {
	 $hashvar = substr($key, $lstriplen);
	 $hashvar = str_replace("%20", " ", $hashvar);
	 $hashval = $value;
	 $dellist[$hashvar] = 1;
      }
   }


   foreach ($hashlist as $foo => $a)
   {
      $key = $a->key;
      $value = $a->value;
      $edit = $a->edit;

      //printf("a: %s => %s (%s)<br>\n",
      //$key, $value, $edit);
      
      if ($dellist[$key])
      {
	 printf("Delete $key...<br>\n");
	 $query = "delete from $table where UID = $uid " .
	    "and name = '$key';";
	 //printf("$query<br>\n");
	 mysql_query($query);
      }
      else
      {
	 printf("Update %s...<br>\n", $key);
	 $query = sprintf("update %s set value = '%s' " .
			  "where UID = %s " .
			  "and name = '%s';",
			  $table, $value, $uid, $key);
	 //printf("%s<br>\n", $query);
	 mysql_query($query);

	 $query = sprintf("update %s set edit = %s " .
			  "where UID = %s " .
			  "and name = '%s';",
			  $table, $edit, $uid, $key);
	 //printf("%s<br>\n", $query);
	 mysql_query($query);
      }
   }


   // Now add any new variables
   $name = $HTTP_POST_VARS["addvar:name"];
   $value = $HTTP_POST_VARS["addvar:value"];
   $edit = $HTTP_POST_VARS["addvar:edit"];
   if($edit == "on") {$edit = 1;}
   else {$edit = 0;}

   if($name)
   {
      printf("New: %s -> %s (%s)<br>\n", $name, $value, $edit);
      $query = sprintf("insert into $table values (%s, '%s', '%s', %s);",
		       $uid, $name, $value, $edit);
      mysql_query($query);
   }
   
   printf("Values have been updated.<br>\n");

   printf("<a href=\"{$SCRIPT_URL}?action=edit_user&uid=%s\">" .
	  "Back to user info</a>\n",
	  $u->UID);
}

function edit_user($auth_user)
{
   // Lets you configure a user's options:
   // - username
   // - password
   // - real name
   // - groups
   // - misc hash options
   // - group-specific options
   //   - permissions
   global $uid;
   
   $db = connect_db();

   $u = create_user_from_db($uid);
   if(! $u) return;

   printf("<table width=\"100%%\"><tr>\n");
   printf("<td>User edit: %s</td>\n", $u->realname);
   echo "<td>
            <a href=\"{$SCRIPT_URL}?action=delete_user&uid={$u->UID}\">
              Delete User
            </a>
         </td>\n";
   printf("<td align=right><a href=\"{$SCRIPT_URL}?action=user_list\">" .
	  "List users</a></td>\n");
   printf("</tr></table>\n");

   $u->load_attribs();
   $u->load_groups();

   user_basic_form($u);

   user_group_form($u);

   if(in_array("edit", $u->groups))
   {
      user_permission_form(&$u);
   }
   
   user_hash_form($u);
   
}

function user_list($auth_user)
{
   global $first, $amount;
   global $SCRIPT_NAME;
   
   if(! $first) $first = 0;
   if(! $amount) $amount = 16;
   if($amount < 1) $amount = 16;
   
   printf("User list:\n");
   
   $db = connect_db();

   $result = mysql_query("SELECT count(ID) from user;");
   $myrow = mysql_fetch_array($result);
   $num_users = $myrow["count(ID)"];

   echo "({$num_users} users)\n<br>\nJump to page:\n";
   for($i=0; $i < $num_users; $i += $amount)
   {
      $pagenum = 1 + ($i / $amount);
      $url = "{$SCRIPT_NAME}?first={$i}&amount={$amount}";
      if($i == $first)
	echo "{$pagenum}\n";
      else
	echo "<a href=\"{$url}\">{$pagenum}</a>\n";
   }
   
   $result = mysql_query("SELECT * from user ORDER BY name;");

   $i = 0;
   $users = array();
   while($myrow = mysql_fetch_array($result))
   {
      if($i >= $first + $amount)
      {
	 break;
      }
      if($i >= $first)
      {
	 $u = user($myrow["ID"], $myrow["user"], $myrow["passwd"], 
		   $myrow["name"]);
	 $users[$i - $first] = $u;
      }
      $i ++;
   }

   echo "<table width=\"100%\"><tr>\n";
   // previous page
   if($first > 0)
   {
      $new_first = $first - $amount;
      if($new_first < 0)  $new_first = 0;
      $prev_link = link_to_self("first", $new_first);
      printf("<td align=left><a href=\"%s\">Previous</a></td>\n",
	     $prev_link);
   }
   // next page
   if($i >= $first + $amount)
   {
      $next_link = link_to_self("first", $first+$amount);
      printf("<td align=right><a href=\"%s\">Next</a></td>\n",
	     $next_link);
   }
   echo "</tr></table>\n";
   
   echo "<hr noshade>\n";
   print "<table>\n";
   print "<tr><td>Real Name</td><td>Username</td></tr>\n";
   print "<tr><td><hr></td><td><hr></td></tr>\n";
   foreach($users as $u)
   {
      $edit_user_link = sprintf("{$SCRIPT_URL}?action=edit_user&uid=%s",
				     $u->UID);
      echo "<tr><td>\n";
      echo "<a href=\"{$edit_user_link}\">{$u->realname}</a>";
      echo "</td>\n<td>\n";
      printf("(%s)\n</td></tr>\n",
	     $u->username);
   }
   printf("</table>\n");
   
}

function delete_user($u)
{
   global $HTTP_GET_VARS;

   $uid = $HTTP_GET_VARS["uid"];

   echo "Delete User: {$uid}<br>\n";

   // TODO: (deleting a user)
   // - Remove entry from user
   // - Remove entries from user_hash
   // - Remove entries from permission
   // - Remove entries from groupdb
   // - Remove market items?

   $queries = array(
      "DELETE FROM user WHERE ID={$uid}",
      "DELETE FROM user_hash WHERE UID={$uid}",
      "DELETE FROM permission WHERE UID={$uid}",
      "DELETE FROM groupdb WHERE UID={$uid}"
      );

   connect_db();

   foreach ($queries as $query)
   {
      mysql_query($query);
   }

   echo "User deleted.<br>\n";
   return;
}

function user_page($auth_user)
{
   global $action;

   if(!$action  or  $action == "user_list")
   {
      user_list(&$auth_user);
   }
   else if ($action == "edit_user")
   {
      edit_user(&$auth_user);
   }
   else if ($action == "edit_user_basic_submit")
   {
      set_user_basic(&$auth_user);
   }
   else if ($action == "edit_user_group_submit")
   {
      set_user_group(&$auth_user);
   }
   else if ($action == "edit_user_hash_submit")
   {
      set_user_hash(&$auth_user);
   }
   else if ($action == "edit_user_permission_submit")
   {
      set_user_permission(&$auth_user);
   }
   else if ($action == "delete_user")
   {
      delete_user(&$auth_user);
   }
}

check_login("admin");
?>

<? include("footer.inc"); ?>
