<?

// (uses $EDIT_DOCUMENT_ROOT, defined in /php/vars.inc)

class permission
{
   var $target;
   var $type;
   var $status;
   
   function gives_access($path, $action)
   {
      //printf("gives_access(%s == %s)<br>\n", $this->type, $action);
      if($action != $this->type)
      {
	 return;
      }

      //printf("gives_access(%s == %s)<br>\n", $this->target, $path);

      $result = array();
      
      $my_target_len = strlen($this->target);

      $path_substr = substr($path, 0, $my_target_len);
      
      if($path_substr == $this->target)
      {
	 $result[0] = $this->status;
	 $result[1] = $my_target_len;
	 //printf("%s!  (%s)<br>\n", $this->status, $my_target_len);
	 return $result;
      }
   }
}

function permission($target, $type, $status)
{
   $p = new permission;
   
   $p->target = $target;
   $p->type = $type;
   $p->status = $status;
   
   return $p;
}

function edit_check_perm($u)
{
   $query = sprintf("SELECT * FROM permission WHERE UID = %s;",
        	       $u->UID);
   //printf("%s<br>\n", $query);
      
   $u->perm = array();
   $num_perms = 0;

   $db_data = mysql_query($query);

   if(! $db_data)
   {
      printf("Error checking user's permissions.<br>\n");
      return;
   }
      
   while($myrow = mysql_fetch_array($db_data))
   {
      $p = permission($myrow["target"], $myrow["type"], $myrow["status"]);

      //printf("Permission: %s -> %s %s for %s<br>\n",
      //     $u->realname, $p->status, $p->type, $p->target);
	 
      $u->perm[$num_perms] = $p;
      $num_perms ++;
   }

   return $u;
}

function can_access($u, $path, $action)
{
   //printf("can_access(%s, %s)<br>\n", $path, $action);
   $authorized = 0;
   $max_len = -1;
   foreach ($u->perm as $p)
   {
      //printf("perm: %s<br>\n", $p->target);
      $result = $p->gives_access($path, $action);
      if($result)
      {
	 $status = $result[0];
	 $len = $result[1];

	 if($len >= $max_len)
	 {
	    //printf("New longer match.<br>\n");
	    $len = $max_len;
	       
	    if($status == "enable")
	       $authorized = 1;
	    else
	       $authorized = 0;
	 }
      }
   }
      
   return $authorized;
}
   
function auth_read_file($auth_user, $filename)
{
   // All file access goes through these functions,
   // so security will actually work.
   // 
   // TODO: check permissions in database
   // TODO: give an error when permission is denied
   global $EDIT_DOCUMENT_ROOT;
   
   $path = $EDIT_DOCUMENT_ROOT . "/" . $filename;
   if (is_dir($path)) { return auth_read_dir($auth_user, $filename); }

   $can_access = can_access($auth_user, $filename, "read");

   if($can_access)
   {
      if(! file_exists($path))
	return;

      $fp = fopen($path, "rb", 0);
      if(! $fp)
	return;
      
      return array($fp, $path);
   }
   else
     return;
}

function auth_is_dir($auth_user, $filename)
{
   global $EDIT_DOCUMENT_ROOT;

   $path = $EDIT_DOCUMENT_ROOT . "/" . $filename;
   return is_dir($path);
}

function auth_read_dir($auth_user, $filename)
{
   global $EDIT_DOCUMENT_ROOT;

   $path = $EDIT_DOCUMENT_ROOT . "/" . $filename;

   $can_access = can_access($auth_user, $filename, "read");
   //printf("auth_read_dir(%s) -> %s<br>\n", $path, $can_access);

   if($can_access)
   {
      if(! file_exists($path))
	return;

      $arr = get_dir_array($path);
      return array($arr, $path);
   }
   else
     return;
}

function auth_has_read($auth_user, $filename)
{
   global $EDIT_DOCUMENT_ROOT;
   
   $path = $EDIT_DOCUMENT_ROOT . "/" . $filename;

   $can_access = can_access($auth_user, $filename, "write");

   return $can_access;
}

function auth_has_write($auth_user, $filename)
{
   global $EDIT_DOCUMENT_ROOT;
   
   $path = $EDIT_DOCUMENT_ROOT . "/" . $filename;

   $can_access = can_access($auth_user, $filename, "write");

   return $can_access;
}

function auth_write_file($auth_user, $filename)
{
   return;
}

include_once("../php/custom.inc");
?>
