<? include("std.inc"); ?>
<? $title = "{$site_name} Help"; ?>
<? include("header.inc"); ?>

<? blurb("About {$site_name}"); ?>

	This system allows you to add/remove/edit your web site content, without
	having to bother learning/using unix or ftp.

	<br /><br />

	The main system lets you create an account, log in, and change your
	preferences.  Additional modules (such as the file editor) are documented
	individually below.

<? blurb_end(); ?>

<? blurb("Quick Start"); ?>

	Using the system is fairly simple.  There are three steps:

	<ol>
	
		<li>Start by logging in.  Open up a web browser and go to
		<a href="<?=$wwwroot?>"><?=$wwwroot?></a>.
		<b>Enter your username and password, then click "Go".</b>
		<br />

		(If you don't yet have an account, click the "new account" link and follow
		directions.)  </li>

		<li>Next you should see a screen saying you are logged in.  There should
		also be two or more links showing courses of action you can take.  For
		example, "My Preferences" will let you configure your account.  "My Home
		Directory" is used to view and edit your files.  <b>Click one of these
		actions to start working.</b></li>

		<li>When you're done using the system, <b>click "Log Out"</b>.</li>

	</ol>

<? blurb_end(); ?>

<? blurb("My Preferences"); ?>

	This function lets you configure your basic account settings.  Your
	settings are split into groups:

	<? blurb("Basic User Info"); ?>

		These are the most important settings.  Your real name probably won't
		change very often (if ever), but you may want to change your password.  The
		default passwords are random, so feel free to change your password to
		something you will remember.

	<? eb(); ?>

	<? blurb("Groups"); ?>

		If you think you need access to more (or fewer) features, you may request
		membership in different groups.  Your administrator will then review your
		request and grant or deny it.

	<? eb(); ?>

	<? blurb("Misc User Options"); ?>

		Other settings are configured here.  Most of them are unimportant.

	<? eb(); ?>

<? blurb_end(); ?>

<? blurb("My Home Directory"); ?>

	If you have a link for "My Home Directory", you have permission to edit
	web content.  Click this link to the folder contents of the area assigned
	to you.<br /><br />

	Detailed information about this topic is available by clicking the
	<? page("edit/help.php", "help"); ?> link in the folder browser.

<? blurb_end(); ?>

<? blurb("My Admin Tools"); ?>

	If you have a link for "My Admin Tools", you are a site administrator.
	<br /><br />
	Help is not yet available for this topic.

<? blurb_end(); ?>

<? include("footer.inc"); ?>
