# MySQL dump 8.13
#
#--------------------------------------------------------
# Server version	3.23.36-log

#
# Table structure for table 'group_options'
#

CREATE TABLE group_options (
  GID int(11) NOT NULL default '0',
  name varchar(255) default NULL,
  def varchar(255) default NULL,
  can_edit int(11) default NULL
) TYPE=MyISAM;

#
# Dumping data for table 'group_options'
#

INSERT INTO group_options VALUES (2,'homedir','/',0);
INSERT INTO group_options VALUES (2,'Textarea Width','60',1);
INSERT INTO group_options VALUES (2,'Textarea Height','20',1);

#
# Table structure for table 'groupdb'
#

CREATE TABLE groupdb (
  GID int(11) NOT NULL default '0',
  UID int(11) NOT NULL default '0'
) TYPE=MyISAM;

#
# Dumping data for table 'groupdb'
#

INSERT INTO groupdb VALUES (1,1);

#
# Table structure for table 'groups'
#

CREATE TABLE groups (
  ID int(11) NOT NULL auto_increment,
  name varchar(32) default NULL,
  description varchar(255) default NULL,
  PRIMARY KEY  (ID)
) TYPE=MyISAM;

#
# Dumping data for table 'groups'
#

INSERT INTO groups VALUES (1,'admin','Web administrator functions.');
INSERT INTO groups VALUES (2,'edit','Ability to create and edit web pages.');

#
# Table structure for table 'pending_user'
#

CREATE TABLE pending_user (
  ID int(11) NOT NULL auto_increment,
  user varchar(64) default NULL,
  passwd varchar(16) default NULL,
  name varchar(255) default NULL,
  email varchar(255) default NULL,
  PRIMARY KEY  (ID)
) TYPE=MyISAM;

#
# Dumping data for table 'pending_user'
#


#
# Table structure for table 'permission'
#

CREATE TABLE permission (
  UID int(11) NOT NULL default '0',
  target varchar(255) default NULL,
  type enum('read','write') default NULL,
  status enum('enable','disable') default NULL
) TYPE=MyISAM;

#
# Dumping data for table 'permission'
#

INSERT INTO permission VALUES (1,'/','read','enable');
INSERT INTO permission VALUES (1,'/','write','enable');

#
# Table structure for table 'user'
#

CREATE TABLE user (
  ID int(11) NOT NULL auto_increment,
  user varchar(64) default NULL,
  passwd varchar(16) default NULL,
  name varchar(255) default NULL,
  email varchar(255) default NULL,
  PRIMARY KEY  (ID)
) TYPE=MyISAM;

#
# Dumping data for table 'user'
#


#
# Table structure for table 'user_hash'
#

CREATE TABLE user_hash (
  UID int(11) NOT NULL default '0',
  name varchar(255) default NULL,
  value varchar(255) default NULL,
  edit int(11) default '0'
) TYPE=MyISAM;

#
# Dumping data for table 'user_hash'
#

INSERT INTO user_hash VALUES (1,'homedir','/',0);

