<? include("std.inc"); ?>
<? include("header.inc"); ?>
<? include("docs.inc"); ?>

<?
func_title("gallery");
args("path", "filename", "Directory images are stored in.");
args("wid", "integer", "Max width of thumbnails", 0, "1-1024", 256);
args("hgt", "integer", "Max height of thumbnails", 0, "1-1024", 192);
args(-1);

?>

Inserts an image gallery into your page.  It automatically creates
image thumbnails and links them to the original images.  It displays
9 images per page, and handles previous and next page links.  Image 
filenames are displayed next to the image.

<p>

More flexibility and options will be added later.

<p>

Example:

<table border=1 width="100%">
  <tr><td width="50%">Code</td><td width="50%">Result</td></tr>
  <tr><td width="50%" valign=top>
<pre>
&lt;? 
include("gallery.inc");
gallery("gfx", 64, 64); 
?&gt;
</pre>
  </td>
  <td width="50%">
<? 
include("gallery.inc");
gallery("gfx", 64, 64); 
?>
  </td></tr>
</table>

<? include("footer.inc"); ?>
