<? include("std.inc"); ?>
<? include("header.inc"); ?>
<? include("docs.inc"); ?>

<?
func_title("search_parents");
args("filename", "filename", "File to search for");
args("directory", "filename", "Directory to add to search", 0, "", "None");
args(-1);

?>

Searches through parent directories to find a file named <i>$filename</i>.
Returns the relative path if found.  Directories will be searched in the
following order:
<ul>
  <li>.</li>
  <li>./$directory</li>
  <li>..</li>
  <li>../$directory</li>
  <li>../..</li>
  <li>../../$directory</li>
  <li>and so on</li>
</ul>
  
<p>
  
Example:

<pre>
&lt;? 
  $my_image = search_parents("title.jpg", "gfx");
?&gt;
</pre>

<? include("footer.inc"); ?>
