<?
// Oops, HTTP POST variables get a few things automatically
// translated..  That's, um, bad.  Here's a workaround.
$encode_trans = array(
   "." => "_dot_",
   " " => "_space_",
   );

function trans_var($v)
{
   // Rewrite a string so that it may be used as a POST variable name
   global $encode_trans;

   return strtr($v, $encode_trans);
}

function trans_post_vars()
{
   // Translate back from trans_var()
   global $HTTP_POST_VARS;
   global $encode_trans;

   $rtrans = array_flip($encode_trans);
   
   foreach ($HTTP_POST_VARS  as  $k => $v)
   {
      $nk = strtr($k, $rtrans);
      if ($nk != $k)
      {
	 //echo "POST_TRANS: {$k} -> {$nk}<br>\n";
	 unset($HTTP_POST_VARS[$k]);
	 $HTTP_POST_VARS[$nk] = $v;
      }
   }
}

function post_var_search($search_text)
{
   // Search through the HTTP_POST_VARS and return a hash of variables
   // which have $search_text at the beginning of the key.
   //
   // post_var_search("db_") will match as follows:
   //    no       PHPSESSID
   //    yes      db_data
   //    no       field_db_2
   //    yes      db_new_value
   //
   global $HTTP_POST_VARS;
   
   $search_len = strlen($search_text);
   $result = array();

   foreach($HTTP_POST_VARS as $k => $v)
   {
      //echo "POST: {$k} = {$v}<br>\n";
      if (substr($k, 0, $search_len)  ==  $search_text)
      {
	 $result[substr($k, $search_len)] = $v;
      }
   }

   return $result;
}

function reverse_htmlspecialchars($text)
{
   $trans = get_html_translation_table (HTML_ENTITIES);
   $trans = array_flip ($trans);
   //foreach($trans as $k => $v)
   //{
   //printf("Trans[%s] = %s<br>\n", $k, $v);
   //}
   $decoded = strtr ($text, $trans);

   //printf("<table border=1><tr><td>%s</tr></td></table>\n", $text);
   //printf("<table border=1><tr><td>%s</tr></td></table>\n", $decoded);
   
   return $decoded;
}

function encode($text)
{
   return addslashes(htmlspecialchars($text));
}

function decode($text)
{
   return reverse_htmlspecialchars(stripslashes($text));
}

function form_continue($method="post")
{
   // Provides multipage forms by adding previous input as hidden fields
   global $HTTP_POST_VARS;
   global $HTTP_GET_VARS;

   if($method == "get")
     $myvars = $HTTP_GET_VARS;
   else
     $myvars = $HTTP_POST_VARS;
   
   foreach ($myvars as $k => $v)
   {
      $v = htmlspecialchars(stripslashes($v));
      echo "<input type=hidden name=\"{$k}\" value=\"{$v}\" />\n";
      //if (trim($v) != "")
      //   $text = $text . "{$k}: {$v}\n";
   }
}

function form_email($email, $subject="", $method="post")
{
   global $HTTP_POST_VARS;
   global $HTTP_GET_VARS;
   global $SCRIPT_NAME;

   if($method == "get")
     $myvars = $HTTP_GET_VARS;
   else
     $myvars = $HTTP_POST_VARS;
   
   if(! $subject)
     $subject = "{$site_name}: Form Submission at {$SCRIPT_NAME}";
   $headers = "From: {$webmaster_email}\n" .
      "X-Mailer: PHP/" . phpversion();
   $text = "The form data:\n\n";

   $fields = array_keys($myvars);
   sort($fields);
   
   foreach ($fields as $k)
   {
      $v = $myvars[$k];
      if (trim($v) != "")
      {
	 $v = reverse_htmlspecialchars(stripslashes($v));
	 $k = reverse_htmlspecialchars(stripslashes($k));
	 $k = str_replace("_", " ", $k);
	 $text = $text . "{$k}: \t{$v}\n";
      }
   }
   
   //print "<b>To:</b> {$email}<br>\n";
   //print "<b>Subject:</b> {$subject}<br>\n";
   //print "<pre>{$text}</pre>\n";
   mail($email, $subject, $text, $headers);
}
?>
