<?
function is_thumb($str)
{
   $look = "thumb_";
   $test = substr($str, 0, strlen($look));
   return ($test != $look);
}

function array_remove($arr, $str, $end="start")
{
   $in = 0;
   $out = 0;
   $in_len = sizeof($arr);
   $str_len = strlen($str);
   $result = array();
   for($in = 0; $in < $in_len; $in++)
   {
      $data = $arr[$in];
      if($end == "start")
      {
	 $test = substr($data, 0, $str_len);
      }
      else
      {
	 $point = strlen($data) - $str_len;
	 if($point < 0)
	    $test = 0;
	 else
	    $test = substr($data, $point, $str_len);
      }
      if($test != $str)
      {
         $result[$out] = $data;
	 $out++;
      }
      /*
      else
      {
	 echo "Filtered: {$data}<br>\n";
      }
      */
   }
   return $result;
}

function nav_bar($first, $amount, $length)
{
   global $PHP_SELF;
   global $HTTP_GET_VARS;
   
   if($length <= $amount)
   {
      return "";
   }
   
   $str = "<!-- Navigation Bar -->\n";
   $str = $str . "<table width=\"100%\"><tr>\n";

   $base_url = $PHP_SELF;
   $first_arg = 1;
   $sep = "?";
   foreach($HTTP_GET_VARS as $key => $value)
   {
      if(($key != "first")  and  ($key != "amount"))
      {
          if($first_arg)
	  {
	     $first_arg = 0;
	     $sep = "&";
	     $base_url = $base_url . "?" . $key . "=" . $value;
	  }
	  else
	  {
	     $base_url = $base_url . "&" . $key . "=" . $value;
	  }
      }
   }

   if($first > 0)
   {
      $new_first = $first - $amount;
      if($new_first < 0) $new_first = 0;
      $str = $str . sprintf("<td align=\"left\">" .
			    "<a href=\"%s%sfirst=%s&amount=%s\">" .
			    "Previous Page</a></td>\n",
			    $base_url, $sep, $new_first, $amount);
   }
   if($amount < $length)
   {
      $str = $str . "<td align=\"center\">\n";
      for($i=0; ($i*$amount)<$length; $i++)
      {
         $str = $str . sprintf("<a href=\"%s%sfirst=%s&amount=%s\">%s</a> \n",
			      $base_url, $sep, $i*$amount, $amount, $i+1);
      }
      $str = $str . "</td>\n";
   }
   if($first + $amount < $length)
   {
      $str = $str . sprintf("<td align=\"right\">" .
			    "<a href=\"%s%sfirst=%s&amount=%s\">" .
			    "Next Page</a></td>",
			    $base_url, $sep, $first + $amount, $amount);
   }
   
   $str = $str . "</tr></table>\n";
   $str = $str . "<!-- END Navigation Bar -->\n";

   return $str;
}

function gallery($path, $wid=256, $hgt=192, $amt=9, $style="default", $columns=3)
{
   global $first;
   global $amount;
   $raw = 0;

   //printf("Gallery(%s)<br>\n", $path);
   
   if (! $amount)
   {
      $amount = $amt;
   }

   // Specify raw mode; don't make thumbnails or scale.
   if($wid <= 0  ||  $hgt <= 0)
   {
      $raw = 1;
   }

   //////////////////////////////
   // Display the images...
   //printf("first: %s<br>\namount: %s<br>\n", $first, $amount);
   // if ((! $first)   or  (! is_int($first)))  { $first = 0; }
   // if ((! $amount)  or  (! is_int($amount))) { $amount = 9; }
   // TODO: validate input to ensure values are numbers!
   if (! (int)$first > 0)  { $first = 0; }
   if (! (int)$amount > 0) { $amount = 9; }
   //printf("first: %s<br>\namount: %s<br>\n", $first, $amount);


   $stuff = look_parents($path);
   if(!$stuff)
     return;
   
   $virt_dir = $stuff[0];
   $real_dir = $stuff[1];

   //printf("file: %s<br>\nd: %s<br>\n", $file, $d);
   
   if($real_dir)
   {
      // Get a file list and remove thumbnail entries...
      $files = get_dir_array($real_dir);
      if(sizeof($files) < 1) { return; }
      //$files = array_filter($files, "is_thumb");
      //$files->filter("is_thumb");
      $files = array_remove($files, "thumb_");  // remove thumbnails
      $files = array_remove($files, ".");  // remove .svn, etc...
      $files = array_remove($files, ".inc", $end="end");  // ignore captions
      $files = array_remove($files, "~", $end="end");  // ignore backups
      $length = sizeof($files);
      $end_num = $first + $amount;
      if($first + $amount > $length)
      {
	 $end_num = $length;
      }
      printf("Showing images %s - %s of %s.\n<hr noshade>\n", 
	     $first + 1, $end_num, $length);

      $nav_text = nav_bar($first, $amount, $length);

      if($nav_text)
      {
	 echo $nav_text;
	 echo "<hr noshade>\n";
      }

      // TODO: implement the "columns" option for better formatting
      
      for($i = $first; ($i < $first + $amount)  &&  ($i < $length); $i++)
      {
	 $f = $virt_dir . "/" . $files[$i];
	 $fdesc = "{$real_dir}/{$files[$i]}.inc";
	 //printf("File: %s<br>\n", $f);
	 if($style == "filename")
	 {
	    echo "<table><tr><td>\n";
	    if($raw) image($f);
	    else thumbnail($f, $wid, $hgt);
	    echo "\n";
	    echo "</td><td>";
	    echo $files[$i];
	    echo "</td></tr></table>\n";
	 }
	 else if($style == "desc")
	 {
	    echo "<table><tr><td>\n";
	    if($raw) image($f);
	    else thumbnail($f, $wid, $hgt);
	    echo "\n";
	    echo "</td><td>";
	    if(file_exists($fdesc))
	    {
	       include($fdesc);
	    }
	    echo "</td></tr></table>\n";
	 }
	 else if($style == "alt")
	 {
	    $text = $f;
	    if (file_exists($fdesc)) {
	       $text = implode("", file($fdesc, 1));
	    }
	    $text = htmlspecialchars($text);
	    if($raw) image($f, $text);
	    else thumbnail($f, $wid, $hgt, 0, $text);
	    echo "\n";
	 }
	 else // if($style == "default"  ||  $style == "plain")
	 {
	    if($raw) image($f);
	    else thumbnail($f, $wid, $hgt);
	    echo "\n";
	 }
      }

      if($nav_text)
      {
	 echo "<hr noshade>\n";
	 echo $nav_text;
      }
   }
}
?>
