<?
function search_file($file, $dir="")
{
   // Find a file using search_parents, and return both its
   // real and virtual locations.
   global $DOCUMENT_ROOT;
   $realfile=$file;
   if ($file[0] == "/")
   {
      $realfile = $DOCUMENT_ROOT . $file;
   }
   else
   {
      $realfile = search_parents($file, $dir);
      if(! $realfile)
      {
	 printf("<!-- Error: unable to find image %s -->", $file);
	 return;
      }
      $file = $realfile;
   }
   return array($file, $realfile);
}

function thumbnail($filename, $wid=64, $hgt=9999, $force=0, $text="", $other="")
{
   // Displays an image thumbnail, creating the thumbnail if
   // it doesn't yet exist.
   // 
   // TODO: implement "force" option (rebuilds thumbnails)
   // TODO: check date on image and thumbnail

   global $convert;
   $prefix = "thumb_";
   $stuff = look_parents($filename, "gfx");
   if(!$stuff)  return;
   
   $virt = $stuff[0];
   $real = $stuff[1];

   if(! $real)
   {
      printf("<!-- Error: Unable to find %s -->", $filename);
      return;
   }
   //printf("Virt: %s<br>\n", $virt);
   //printf("Real: %s<br>\n", $real);
   // sizeof(), basename(), dirname()

   $real_dir = dirname($real);
   $real_file = basename($real);
   $thumb_real = $real_dir . "/" . $prefix . $real_file;

   $virt_dir = dirname($virt);
   $virt_file = basename($virt);
   $thumb_virt = $virt_dir . "/" . $prefix . $virt_file;
   //printf("dir: %s<br>\n", $base_dir);
   //printf("file: %s<br>\n", $base_file);
   //printf("thumb: %s<br>\n", $thumb_real);
   //printf("thumb: %s<br>\n", $thumb_virt);

   if(substr($base_file, 0, 6) == "thumb_")
   {
      printf("<!-- Error: thumbnail() called on a thumbnail image. -->");
      return;
   }

   // Check whether to recreate the thumbnail
   $build = 0;
   if (! file_exists($thumb_real))
   {
      $build = 1;
   }
   else if ($force)
   {
      $build = 1;
   }
   else if (is_newer($real, $thumb_real))
   {
      $build = 1;
   }
   // compare dates...
   
   if(! $build)
   {
      printf("<A HREF=\"%s\">", $virt);
      image($thumb_virt, $text, $other);
      printf("</A>");
   }
   else
   {
      //echo "<!-- Rebuilding thumbnail -->\n";
      $cmd = sprintf("%s -geometry %sx%s %s %s",
		     $convert, $wid, $hgt, $real, $thumb_real);
      //printf("Executing %s<br>\n", $cmd);
      $err = system($cmd);
      //printf("Returned %s<br>\n", $err);
      
      printf("<A HREF=\"%s\">", $virt);
      image($thumb_virt, $text, $other);
      printf("</A>");
   }
}
?>
