<? include("std.inc"); ?>
<? $title = "{$site_name} Link Admin"; ?>
<? include("header.inc"); ?>
<? include("links/php/links.inc"); ?>

<?

function list_links()
{
   global $section;
   global $display;
   global $approved;
   global $first, $amount;

   if(! (int)$first > 0) { $first = 0; }
   if(! (int)$amount > 0) { $amount = 12; }

   echo "<a href=\"index.php?action=add_form\">Add New Link</a><br>\n";

   echo "<a href=\"help.php\">Help with the Link Editor</a><br>\n";
   
   connect_db();
   if($approved == "yes") $approved = 1;
   else if($approved == "no") $approved = 0;
   else $approved = -1;
   $links = load_all_links($section, $approved);
   $numlinks = sizeof($links);
   
   //if($numlinks > $amount)
   if(1)
   {
      print "Jump to page:\n";
      for($i=0; $i < $numlinks/$amount; $i++)
      {
	 $f = $i * $amount;
	 $p = $i + 1;
         print "<a href=\"{$SCRIPT_NAME}?first={$f}&amount={$amount}\">{$p}</a>\n";
      }
      print "<br>\n";
   }

   if($first + $amount >= $numlinks) { $amount = $numlinks - $first; }

   echo "<table border=1 width=\"100%\">\n";
   echo "<tr><td>ID</td><td>Title</td><td>URL</td><td>Section</td>" .
     "<td>Approved</td><td></td></tr>\n";
   //foreach($links as $l)
   for($i=$first ; $i < $first + $amount; $i++)
   {
      $l = $links[$i];
      echo "<tr>\n";
      
      $url = "index.php?action=edit_form&ID={$l->ID}";
      echo "<td valign=top><a href=\"{$url}\">{$l->ID}</a></td>\n";
      echo "<td valign=top><a href=\"{$url}\">{$l->title}</a></td>\n";
      echo "<td valign=top><a href=\"{$url}\">{$l->url}</a></td>\n";
      $url = "index.php?action=list&section={$l->section}";
      echo "<td valign=top><a href=\"{$url}\">{$l->section}</a></td>\n";
      $url = sprintf("index.php?action=list&approved=%s",
		     $l->approved ? "yes" : "no");
      printf("<td valign=top><a href=\"{$url}\">%s</a></td>\n",
	     $l->approved ? "Yes" : "No");
      $url = "index.php?action=del&ID={$l->ID}";
      echo "<td valign=top><a href=\"{$url}\">Delete Link</a></td>\n";
      if($display) { echo "<td>\n"; $l->display(); echo "</td>\n"; }

      //$data = array($l->ID, $l->title, $l->url, $l->section);
      //foreach($data as $d)
      //{
      //	 echo "<td valign=top><a href=\"{$url}\">{$d}</a></td>\n";
      //}
      echo "</tr>\n";
   }
   echo "</table>\n";
}

function del_link()
{
   global $ID;

   if ($ID > 0)
   {
      connect_db();
      $l = new linkitem;
      $l->load($ID);
      $l->del();
      echo "Link deleted: {$l->title}<br>\n";
   }
   else
   {
      echo "Invalid link ID.<br>\n";
   }
   list_links();
}

function edit_form($ID="")
{
   if(! $ID)
   {
      echo "<h2>Add Link</h2>\n";
      $form_action = "index.php?action=add_submit";
      $l = new linkitem;
      $submittext = "Add Link";
   }
   else
   {
      connect_db();
      echo "<h2>Edit Link</h2>\n";
      $form_action = "index.php?action=edit_submit";
      $l = new linkitem;
      $l->load($ID);
      $submittext = "Save Changes";
   }
   echo "<form action=\"{$form_action}\" method=post>\n";
   echo "<input type=hidden name=link_id value=\"{$l->ID}\"/>\n";
   echo "<table width=\"100%\">\n";
   echo "<tr><td align=right valign=top>Title</td>\n<td width=\"100%\">";
   //printf ("<textarea name=link_title>%s</textarea>\n",
   printf ("<input type=text name=link_title value=\"%s\" />\n",
	   htmlspecialchars($l->title));
   echo "</td></tr>\n";
   echo "<tr><td align=right valign=top>URL</td>\n<td width=\"100%\">";
   printf ("<input type=text name=link_url value=\"%s\" />\n",
	   htmlspecialchars($l->url));
   echo "<a href=\"{$l->url}\">{$l->url}</a>\n";
   echo "</td></tr>\n";
   echo "<tr><td align=right valign=top>Description</td>\n<td width=\"100%\">";
   printf ("<textarea name=link_text rows=5 cols=60>%s</textarea>\n",
	   htmlspecialchars($l->text));
   echo "</td></tr>\n";
   echo "<tr><td align=right valign=top>Section</td>\n<td>";
   printf ("<input type=text name=link_section value=\"%s\">\n",
	   htmlspecialchars($l->section));
   echo "</td></tr>\n";
   echo "<tr><td align=right valign=top>Approved?</td>\n<td>";
   printf ("<input type=checkbox name=link_approved %s>\n",
	   $l->approved ? "checked" : "");
   echo "</td></tr>\n";
   echo "<tr><td colspan=2 width=\"100%\" align=left>";
   echo "<input type=submit value=\"{$submittext}\" />\n";
   echo "</td></tr>\n";
   echo "</table>\n";
   echo "</form>\n";
   ?>
   <p>
   <ul>
     <li>Try to make sure each link has a description before approval.</li>
     <li>It may be necessary to follow the link and make up a description, if the user leaves the description empty.</li>
     <li>Be sure to check each URL before approving new links!</li>
   </ul>
   <?
}

function edit_submit()
{
   global $HTTP_POST_VARS;

   connect_db();

   $l = linkitem($HTTP_POST_VARS["link_id"],
		 reverse_htmlspecialchars(stripslashes($HTTP_POST_VARS["link_url"])),
		 reverse_htmlspecialchars(stripslashes($HTTP_POST_VARS["link_title"])),
		 reverse_htmlspecialchars(stripslashes($HTTP_POST_VARS["link_text"])),
		 reverse_htmlspecialchars(stripslashes($HTTP_POST_VARS["link_section"])),
		 $HTTP_POST_VARS["link_approved"] == "on" ? 1 : 0
      );

   $l->save();

   list_links();
}

function user_page($auth_user)
{
   global $action;
   
   if($action == ""  or  $action == "list")
   {
      list_links();
   }
   elseif($action == "del")
   {
      del_link();
   }
   elseif($action == "add_form")
   {
      edit_form();
   }
   elseif($action == "add_submit")
   {
      edit_submit();
   }
   elseif($action == "edit_form")
   {
      global $ID;
      edit_form($ID);
   }
   elseif($action == "edit_submit")
   {
      edit_submit();
   }
   else
   {
      echo "What chew talkin' 'bout, Willis?<br>\n";
   }
}

// Authenticates the user, and calls user_page() if successful.
// Argument is the name of a group the user must be in.
check_login("links");
?>

<? include("footer.inc"); ?>
