<? include("std.inc"); ?>
<? $title = "{$site_name}: New User Account"; ?>
<? include("header.inc"); ?>
<?

/*
  Steps for creating a user:

  - User fills out a form:
    - desired username
    - real name
    - valid email address

  - User receives email at email address, containing a password

  - User can then log in
    (on the first login, user data is transferred from pending to a
     real user account)
 */

function new_user_form()
{
   //echo "New user form.<br>\n";

   // Ask user for various info...
   // - desired username (must be 0-9a-zA-Z_.+!*'(),-$, plus spaces)
   // - real name
   // - email address

   $url = "new_user.php?action=new_user_submit";
   echo "
     <h2>I'm a New User!</h2>

     What?  You don't have an account yet?  Well enter your preferred
     nick name here:

     <form method=post action=\"{$url}\" />
       <table>
         <tr>
	   <td align=right>Desired username:</td>
	   <td><input type=text name=\"new_user_username\" /></td>
	   <td>Note: only the characters 0-9a-zA-Z_.+!*(),-$,
	       plus space, are allowed in nicknames, and all others will be
	       stripped out.</td>
	 </tr>
         <tr>
	   <td align=right>Real name:</td>
	   <td><input type=text name=\"new_user_realname\" /></td>
	   <td></td>
	 </tr>
         <tr>
	   <td align=right>Valid email address:</td>
	   <td><input type=text name=\"new_user_email\" /></td>
	   <td>A valid email address address is required to send
	       your registration information.</td>
	 </tr>
       </table>

       <input type=submit value=\"Go!\" />
       <input type=reset value=\"Nevermind...\" />
     </form>
   ";
}

function char_filter($text, $allowed)
{
   // TODO: filter the text!
   return $text;
}

function rand_passwd ($pass_len = 10)
{
   // generate a random password
   // TODO: change this to run "pwgen --no-numerals --no-capitalize 10 1"
   $allchar = "abcdefghijklnmopqrstuvwxyzABCDEFGHIJKLNMOPQRSTUVWXYZ" .
      "0123456789-.";
   //$allchar = "abcdefghijklnmopqrstuvwxyzABCDEFGHIJKLNMOPQRSTUVWXYZ" .
   //   "0123456789-.=+;!$*";
   mt_srand ((double) microtime() * 1000000);
   for ($i = 0, $str = "", $sz = strlen($allchar); $i < $pass_len; ++$i)
      $str .= $allchar[mt_rand(0, $sz)];

   return ($str);
}

function new_user_submit()
{
   echo "New user submit.<br>\n";

   global $HTTP_POST_VARS;
   global $site_name;
   global $webmaster_email;
   $name_chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ" .
      "0123456789_.+!*,-$() ";
   
   // Verify user info..
   $username = $HTTP_POST_VARS["new_user_username"];
   $realname = $HTTP_POST_VARS["new_user_realname"];
   $email = $HTTP_POST_VARS["new_user_email"];

   $username = char_filter($username, $name_chars);
   
   if((! $username)  or  (! $realname)  or  (! $email))
   {
      echo "Missing information.  Fill out <i>all</i> fields!<br>\n";
      new_user_form();
      return;
   }
   
   // Ensure requested user doesn't already exist.
   connect_db();
   
   $query = "SELECT * from user " .
      "WHERE user='{$username}';";
   $query2 = "SELECT * from pending_user " .
      "WHERE user='{$username}';";

   $result = mysql_query($query);
   $result2 = mysql_query($query2);

   if(mysql_fetch_array($result)  or  mysql_fetch_array($result2))
   {
      echo "That user already exists!<br>
            Please choose a different username.<br>\n";
      new_user_form();
      return;
   }

   // Generate a password
   $passwd = rand_passwd();
   //echo "Your password: {$passwd}<br>\n";
   
   // Email a password to the user.
   $to = $email;
   $subject = "{$site_name} account authorization";
   $message = "Hello, {$realname}.
Welcome to {$site_name}.

Your account information:
  - Username: {$username}
  - Password: {$passwd}
  - Email Address: {$email}
  - Real Name: {$realname}

Please save this message or print it so you
don't forget your password!

This message was automatically generated.  Do not reply.

";
   $headers = "From: {$webmaster_email}\n" .
      "Reply-To: {$webmaster_email}\n" .
      "X-Mailer: PHP/" . phpversion();
   mail($to, $subject, $message, $headers);
   
   // Enter info into the pending_user table in the database.
   $query = "INSERT INTO pending_user VALUES " .
      "('', '{$username}', '{$passwd}', '{$realname}', '{$email}');";
   //echo "Query: {$query}<br>\n";
   mysql_query($query);

   echo "Your account has been created.  A message has been sent to your
         email address containing your Log In password.<br>\n";
}


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

if((! $action)  or  ($action == "new_user_form"))
{
   new_user_form();
}
else if($action == "new_user_submit")
{
   new_user_submit();
}

?>
<? include("footer.inc"); ?>
