<?
include("db.inc");
include_once("form.inc");
include_once("fileutils.inc");
include("user_session.inc");

include_once("blurb.inc");

//////////////////////////////////////////////////////////////////////
// These must be defined after the user classes,
// but before the html starts.
//
session_start();
session_register("auth_user");
header ("Cache-Control: no-cache, must-revalidate");  // HTTP/1.1
header ("Pragma: no-cache");                          // HTTP/1.0

function destroy_session()
{
   session_destroy();
   $p = session_get_cookie_params();
   setcookie(session_name(), "", 0, $p["path"], $p["domain"]);
}

if($auth_user)
{
   $timeout = 60*60*2;  // 120 minutes
   $curtime = time();
   
   if($auth_user->lastviewtime)
   {
      $elapsed = $curtime - $auth_user->lastviewtime;

      //echo "elapsed: {$elapsed}<br>\n";

      if($elapsed > $timeout)
      {
	 //echo "This session has expired.
         //      Please <a href=\"/user/\">Log in</a> again.<br>\n";
	 $action = "expire";
	 destroy_session();
	 $auth_user = NULL;
	 return;
      }
      else
      {
	 $auth_user->lastviewtime = $curtime;
      }
   }
   else
   {
      //echo "ARCGRCOAUGARCU!!<br>\n";
      $auth_user->lastviewtime = time();
   }
}

if ($action == "logout")
{
   destroy_session();
   $auth_user = NULL;

   $HTTP_POST_VARS = NULL;
   $HTTP_GET_VARS = NULL;

   //$action = NULL;
   
   //printf("You have been logged out.\n");
   return;
}

?>
