<?
include_once("options.inc");

class user_attribute
{
   var $key;
   var $value;
   var $edit;
}
function user_attribute($key, $value, $edit)
{
   $u = new user_attribute;

   $u->key = $key;
   $u->value = $value;
   $u->edit = $edit;

   return $u;
}

class user
{
   var $UID;
   var $username;
   var $passwd;
   var $realname;
   var $email;
   var $groups;
   
   var $perm;
   var $attribs;

   var $lastviewtime;
   
   var $filelist;
   var $filemode;

   function set($row)
   {
      $this->UID = $row["ID"];
      $this->username = stripslashes($row["user"]);
      $this->passwd   = stripslashes($row["passwd"]);
      $this->realname = stripslashes($row["name"]);
      $this->email    = stripslashes($row["email"]);
   }
   
   function load($uid=-1)
   {
      if($uid >= 0) { $this->UID = $uid; }
      $query = "select * from user where ID={$this->UID};";
      
      $db_data = query_error($query);

      if(! $db_data) return;

      $myrow = mysql_fetch_array($db_data);
      $this->set($myrow);
   }

   function save()
   {
      echo "Saving user info...<br>\n";
      if ($this->UID)
      {
	 $query = sprintf("update user set " .
			  "user='%s', passwd='%s', name='%s', email='%s' " .
			  "where ID=%s;",
			  addslashes($this->username),
			  addslashes($this->passwd),
			  addslashes($this->realname),
			  addslashes($this->email),
			  $this->UID);
      } else {
	 $query = sprintf("insert into user values ('', " .
			  "'%s', '%s', '%s', '%s');",
			  addslashes($this->username),
			  addslashes($this->passwd),
			  addslashes($this->realname),
			  addslashes($this->email));
      }

      //echo "Query: {$query}<br>\n";
      query_error($query);

      if (! $this->UID)  $this->UID = mysql_insert_id();
   }
   
   function load_groups()
   {
      $query = sprintf("select groups.name " .
		       "from user, groups, groupdb " .
		       "where user.ID = groupdb.UID  " .
		       "and  groups.ID = groupdb.GID  " .
		       "and  user.ID = %s;",
        	       $this->UID);
      //printf("%s<br>\n", $query);
      
      $this->groups = array();
      $num_groups = 0;

      $db_data = mysql_query($query);

      if(! $db_data)
      {
	 printf("Error checking user's groups.<br>\n");
	 return;
      }
      
      while($myrow = mysql_fetch_array($db_data))
      {
	 $group = $myrow["name"];
	 
	 //printf("Group: %s<br>\n",
	 //	$group);
	 
	 $this->groups[$num_groups] = $group;
	 $num_groups ++;
      }

      return sizeof($this->groups);
   }
   
   function load_attribs()
   {
      $query = sprintf("select * " .
		       "from user_hash " .
		       "where  UID = %s;",
        	       $this->UID);
      //printf("%s<br>\n", $query);
      
      $this->attribs = array();
      $num_attribs = 0;

      $db_data = mysql_query($query);

      if(! $db_data)
      {
	 printf("Error checking user's attribs.<br>\n");
	 return;
      }
      
      while($myrow = mysql_fetch_array($db_data))
      {
	 //foreach ($myrow as $key => $value)
	 //   {
	 //      printf("%s => %s<br>\n", $key, $value);
	 //   }
	 
	 $name = $myrow["name"];
	 $value = $myrow["value"];
	 $edit = $myrow["edit"];

	 $a = user_attribute($name, $value, $edit);
	    
	 //printf("Attrib: %s -> %s (%s)<br>\n",
	 //	$name, $value, $edit);
	 
	 $this->attribs[$name] = $a;
	 $num_attribs ++;
      }

      return $num_attribs;
   }

   function save_attribs()
   {
      if(! $this->UID) return;
      
      // Delete existing entries
      $query = "delete from user_hash where UID={$this->UID};";
      //echo "Q: $query <br>\n";
      query_error($query);

      foreach ($this->attribs as $k => $a)
      {
	 if ($a->value == "") continue;
	 // Save new entries
	 $query = sprintf("insert into user_hash values " .
			  "(%s, '%s', '%s', %s);",
			  $this->UID,
			  addslashes($a->key),
			  addslashes($a->value),
			  $a->edit);
	 //echo "Query: {$query}<br>\n";
	 query_error($query);
	 
      }
   }

   function show_short_options()
   {
      global $user_options;
      global $user_bg_color;
      global $user_border_color;
      $bg_color = $user_bg_color;
      $bg_border = $user_border_color;
      $prefs_link = make_page("user/prefs/", "Preferences");
      
      echo "<table class=\"opts_box\"><tr><td class=\"opts_left\">\n";

      echo "<div class=\"option\">My {$prefs_link}</div>\n";

      //echo "</small></td><td align=center valign=top><small>\n";

      // TODO: get an option list from options.inc
      if(is_array($this->groups))
      {
	 foreach($user_options  as  $o)
	 {
	    $g = $o[0];
	    $l = $o[1];
	    if(in_array($g, $this->groups))
	    {
	       print "<div class=\"option\">{$l}</div>\n";
	    }
	 }

	 /*
	 foreach($this->groups  as  $group)
	 {
	    if($group == "admin")
	    {
	       printf("My <a href=\"%s\">Admin Tools</a><br>\n",
		      "/user/admin/");
	    }
	    else if($group == "cable")
	    {
	       echo "My <a href=\"/user/cable/\">Cable TV Channel</a><br>\n";
	    }
	    else if($group == "communities")
	    {
	       echo "My <a href=\"/user/communities/\">Community Database</a><br>\n";
	    }
	    else if($group == "links")
	    {
	       echo "My <a href=\"/user/links/\">Link Management</a><br>\n";
	    }
	    else if($group == "edit")
	    {
	       if(array_has_key($this->attribs, "homedir"))
	       {
		  //$home_link = link_to_self("page",
		  //$this->attribs["homedir"]->value);
		  $home_link = sprintf("/user/edit/?page=%s",
				       $this->attribs["homedir"]->value);
		  printf("My <a href=\"%s\">Home Directory</a><br>\n",
			 $home_link);
	       }
	       else
	       {
		  printf("<a href=\"%s\">Edit Pages</a><br>\n",
			 "/user/edit/");
	       }
	    }
	 }
	 */
      }
      else
      {
	 printf("No Groups.<br />\n");
      }
      
      echo "</td><td class=\"opts_right\">\n";
      
      printf("User: %s (%s)<br>\n", $this->realname, $this->username);

      //$target = link_to_self("action", "logout");
      $target = "user/index.php?action=logout";
      page($target, "Log Out");
      
      printf("</td></tr></table>\n");
   }

   function destroy()
   {
      $this->UID = NULL;
      $this->username = NULL;
      $this->passwd = NULL;
      $this->realname = NULL;
      $this->groups = NULL;
      $this->perm = NULL;
      $this->attribs = NULL;
   }
}

function user($UID, $username, $passwd, $realname, $email="")
{
   $u = new user;

   $u->UID = $UID;
   $u->username = $username;
   $u->passwd = $passwd;
   $u->realname = $realname;
   $u->email = $email;
   
   return $u;
}

function create_user_from_db($uid)
{
   $query = sprintf("SELECT * from user where ID = %s;", $uid);
   
   $result = mysql_query($query);

   if($myrow = mysql_fetch_array($result))
   {
      $u = user($myrow["ID"], $myrow["user"], $myrow["passwd"], 
		$myrow["name"], $myrow["email"]);
   }
   else
   {
      printf("Error looking up user data.<br>\n");
      return;
   }

   return $u;
}


class group
{
   var $ID;
   var $name;
   var $desc;
}

function group($ID, $name, $desc)
{
   $g = new group;

   $g->ID = $ID;
   $g->name = $name;
   $g->desc = $desc;

   return $g;
}

function load_all_groups()
{
   $query = sprintf("select * " .
		    "from groups;");
      
   $groups = array();

   $db_data = mysql_query($query);

   if(! $db_data)
   {
      printf("Error checking group list.<br>\n");
      return;
   }
   
   while($myrow = mysql_fetch_array($db_data))
   {
      $groups[$myrow["ID"]] = group($myrow["ID"], $myrow["name"],
				    $myrow["description"]);
   }
   
   return $groups;
}

function path_normalize($path)
{
   $path = str_replace("//", "/", $path);
   $path = str_replace("//", "/", $path);
   return $path;
}

function link_to_self($name, $value)
{
   global $HTTP_GET_VARS;
   global $PHP_SELF;
   
   $base_url = $PHP_SELF;
   $first_arg = 1;
   $sep = "?";
   $keys = array();

   $temp = strstr($base_url, "?");
   $pos = strlen($base_url) - strlen($temp);
   //printf("Pos: %s<br>\n", $pos);
   if ($pos >= "0") {
      //printf("Base url before: %s<br>\n", $base_url);
      $base_url = substr($base_url, 0, $pos);
      //printf("Base url after: %s<br>\n", $base_url);
   }
   
   foreach ($HTTP_GET_VARS as $key => $keyval)
   {
      if(($key != $name)  and  ($key != "PHPSESSID"))
      {
	 $base_url = $base_url . $sep . $key . "=" . $keyval;
	 
	 $keys[$key] = 1;
	 if($first_arg)
	 {
	    $first_arg = 0;
	    $sep = "&";
	 }
	 //printf("URL: %s<br>\n", $base_url);
      }
   }
   $base_url = $base_url . $sep . $name . "=" . $value;
   
   return $base_url;
}

function login_form()
{
   global $HTTP_GET_VARS;

   // show a login form
   //echo "<br><hr noshade>\n";
   echo "Log in:\n";

   echo "(Forgot your \n";
   page("forgot_password.php", "password");
   echo "?)<br>\n";

   blurb("Log In");
   //echo "login_form();<br>\n";

   printf("<form method=post action=\"%s\">\n", $PHP_SELF);
   ?>
     Username:  <input type=text name="User"><p>
     Password:  <input type=password name="Passwd"><p>
     <input type=submit value="Go">
     <input type=reset value="Nevermind..."><br>
     </form>
   <?
   
   blurb_end();

   $url = "new_user.php";
   /* Retain GET vars...  Oops, screws with new user forms.  :(
   $url = "/user/new_user.php";
   $first=1;
   foreach ($HTTP_GET_VARS as $k => $v)
   {
      if ($first)
      {
         $url = "{$url}?{$k}={$v}";
	 $first = 0;
      }
      else
      {
         $url = "{$url}&{$k}={$v}";
	 $first = 0;
      }
   }
   */
   
   echo "Or, create a \n";
   page($url, "new account");
   //echo "<br><hr noshade>\n";
}

function verify_user($name, $passwd, $allow_pending=1)
{
   // Check if user is valid.
   // If so, return their authenticated user ID.
   //printf("verify_user(<i><b>%s</b></i>, <i><b>%s</b></i>);<br>\n",
   //	  $name, "********");

   $found_user = "";
   
   $db = connect_db();
   if(!$db)
   {
      printf("Unable to access user database.<br>\n");
      return;
   }

   $query = sprintf("SELECT * FROM user " .
		    "WHERE user='%s' AND passwd='%s';",
		    $name, $passwd);
   
   $result = mysql_query($query, $db);
   
   if($myrow = mysql_fetch_array($result))
   {
      $u = user($myrow["ID"], $myrow["user"], $myrow["passwd"], 
		$myrow["name"], $myrow["email"]);
      //printf("Successful login for %s.<br>\n", $u->realname);
      $found_user = $u;
   }

   if($found_user)
   {
      // Grab all user-specific variables, and groups...
      $num_groups = $found_user->load_groups($db);
      //printf("Found %s groups.<br>\n", $num_groups);

      $num_attribs = $found_user->load_attribs($db);
      //printf("Found %s attribs<br>\n", $num_attribs);

      /*  Only for page-editing
      $num_perms = $found_user->check_perm($db);
      if(! $num_perms)
	return;
      */
      return $found_user;
   }

   // Check for pending users, and create their accounts
   else if ($allow_pending)
   {
      $query = sprintf("SELECT * FROM pending_user " .
		       "WHERE user='%s' AND passwd='%s';",
		       $name, $passwd);
   
      $result = mysql_query($query, $db);
   
      if($myrow = mysql_fetch_array($result))
      {
	 $u = user($myrow["ID"], $myrow["user"], $myrow["passwd"], 
		   $myrow["name"], $myrow["email"]);
	 //printf("Successful login for %s.<br>\n", $u->realname);
	 $found_user = $u;
      }

      if($found_user)
      {
	 // Create entry in user table
	 $query = "INSERT INTO user " .
	    "VALUES ('', '{$found_user->username}', " .
	    "'{$found_user->passwd}', " .
	    "'{$found_user->realname}', " .
	    "'{$found_user->email}');";

	 //echo "Q: {$query}<br>\n";
	 mysql_query($query);

	 // Remove entry in pending_user table
	 $query = "DELETE FROM pending_user WHERE ID={$found_user->UID};";

	 //echo "Q: {$query}<br>\n";
	 mysql_query($query);

	 return verify_user($found_user->username, $found_user->passwd, 0);
      }
   }

   return $found_user;
}

function check_login($group="")
{
   // This must be run at the top of each user page.
   // It will call "user_page(&$auth_user)" if the user is logged in.
   global $auth_user;
   global $User;
   global $Passwd;

   // Already logged in
   if ($auth_user)
   {
      // Regular logged-in page view
      if((! $group)  or  (in_array($group, $auth_user->groups)))
      {
	 $auth_user->show_short_options();
	 user_page(&$auth_user);
      }
      // Attempt to access the wrong page
      else
      {
	 printf("Unauthorized.<br>\n");
      }
   }
   // User not logged in
   else
   {
      if($User  and  $Passwd)
      {
	 $auth_user = verify_user($User, $Passwd);
	 if ($auth_user)
	 {
	    if((! $group)  or  (in_array($group, $auth_user->groups)))
	    {
	       $auth_user->show_short_options();
	       user_page(&$auth_user);
	       //echo "Successful login.<br>\n";
	    }
	    else
	    {
	       printf("Unauthorized.<br>\n");
	    }
	 }
	 else
	 {
	    echo "Invalid name or password<br>\n";
	    login_form();
	 }
      }
      // User not yet logged in, or
      // User has logged out, or
      // User's session expired
      else
      {
	 global $action;

	 if($action == "logout")
	 {
	    printf("You have been logged out.<br>\n");
	    page("user/", "Log in");
	    return;
	 }
	 if($action == "expire")
	 {
	    printf("Your session has expired.<br>\n");
	    page("user/", "Log in");
	    return;
	 }
   
	 //echo "You must log in before going further.<br>\n";
	 login_form();
      }
      
   }
}

?>
