<? include("std.inc"); ?>
<? $title = "{$site_name} Access Request"; ?>
<? include("header.inc"); ?>

<?
function request_access_form($u)
{
   global $SCRIPT_NAME;
   blurb("Request More (or less) Access");

   $form_action = "{$SCRIPT_NAME}?action=request_access_submit";
   echo "<form method=post action=\"{$form_action}\">\n";
   
   // Get a grouplist
   connect_db();
   $groups = load_all_groups();


   echo "This is your current group membership status.\n";
   echo "Check or uncheck boxes to request changes to your access.\n";
   echo "<hr noshade>\n";

   echo "<table>\n";
   foreach ($groups as $g)
   {
      //$gid = $g->ID;
      //$group = $g->name;
      
      printf("<tr><td align=right valign=top>%s</td>\n",
	     $g->name);
      $check_name = sprintf("enablegroup:%s", trans_var($g->name));
      $checked = "";
      if(in_array($g->name, $u->groups))  $checked = "checked";
      printf("<td><input type=checkbox name=\"%s\" %s></td>\n",
	     $check_name, $checked);
      printf("<td valign=top>%s</td>\n", $g->desc);
      printf("</tr>\n");
   }
   echo "</table>\n";
   echo "<hr noshade>\n";

   echo "Explain why you should have the access you request.<br>";
   $cols = $u->attribs["Textarea Width"]->value;
   if(!$cols) $cols = 60;
   $rows = $u->attribs["Textarea Height"]->value;
   if(!$rows) $rows = 20;
   echo "<textarea name=access_reasons cols={$cols} rows=${rows}>" . 
      "</textarea><br>\n";

   echo "<input type=submit value=\"Go\">\n";
   echo "<input type=reset value=\"Nevermind...\">\n";
   
   echo "</form>\n";
   eb();
}

function request_access_submit($u)
{
   global $HTTP_POST_VARS;

   // get list of selected groups
   // get list of group membership
   // calculate groups added
   // calculate groups removed
   // send email to site admin with added/removed groups, plus reasons.

   $post_groups = post_var_search("enablegroup:");
   $reasons = stripslashes(reverse_htmlspecialchars($HTTP_POST_VARS["access_reasons"]));

   /*
   foreach ($post_groups as $k => $p)
   {
      if($p == "on")
	 echo "Group: {$k}<br>\n";
   }
   echo "<hr>\n";
   foreach($u->groups as $g)
   {
      echo "Group: {$g}<br>\n";
   }
   */

   $added = array();
   $removed = array();

   echo "Group changes requested:<br>\n<blockquote>\n";

   foreach ($post_groups as $g => $v)
   {
      //echo "Checking for add: {$g}<br>\n";
      if(! in_array($g, $u->groups))
      {
	 array_push($added, $g);
	 echo "Add: {$g}<br>\n";
      }
   }

   foreach ($u->groups as $g)
   {
      //echo "Checking for remove: {$g}<br>\n";
      if(! array_has_key($post_groups, $g))
      {
	 array_push($removed, $g);
	 echo "Remove: {$g}<br>\n";
      }
   }

   echo "</blockquote>\n";

   //echo "Your reasons:\n<hr>\n";
   //printf("%s", htmlspecialchars($reasons));
   //printf("%s", $reasons);
   //echo "<hr>\n";

   // Email a password to the user.
   //$to = "scott@localhost";
   // FIXME: mail to members of admin group...


   // Get a list of all users in the admin group,
   // and send mail to them instead of site admins.
   $query = "select user.email from user,groups,groupdb " .
      "where groups.name = 'admin' " .
      "and groups.ID = groupdb.GID " .
      "and groupdb.UID = user.ID;";

   connect_db();
   $db_data = mysql_query($query);
   $addresses = array();

   while($myrow = mysql_fetch_array($db_data))
   {
      array_push($addresses, $myrow["email"]);
   }

   global $site_name;
   global $site_admin_email;
   $to = "";
   foreach ($addresses as $a)
   {
      $to = "{$a}, {$to}";
   }
   if($to == "") $to = "{$site_admin_email}";
   
   $subject = "{$site_name} access change request for {$u->username}";
   $message = "{$u->realname} ($u->username) has requested access changes.

Their account information:
  - UID:           {$u->UID}
  - Username:      {$u->username}
  - Email Address: {$u->email}
  - Real Name:     {$u->realname}

The following changes have been requested:

";
   foreach ($added as $g)
   {
      $message = $message . "Add: {$g}\n";
   }
   foreach ($removed as $g)
   {
      $message = $message . "Remove: {$g}\n";
   }
   $message = $message . "\nThe following reasons were given:
------------------------------------------------------------
{$reasons}
------------------------------------------------------------

(eot)
";
   

   global $webmaster_email;
   $headers = "From: {$webmaster_email}\n" .
      "Reply-To: {$u->email}\n" .
      "X-Mailer: PHP/" . phpversion();
   mail($to, $subject, $message, $headers);
   /*
   echo "Your message:\n<hr>\n<pre>
To: {$to}
{$headers}
Subject: {$subject}

{$message}
</pre>\n<hr>\n";
   */
   echo "Your request will be processed soon.<br>\n";
   page("index.php", "Back");
}

function user_page($auth_user)
{
   global $action;

   if(!$action)
   {
      request_access_form($auth_user);
   }
   else if($action == "request_access_submit")
   {
      request_access_submit($auth_user);
   }
}

check_login();
?>

<? include("footer.inc"); ?>
