<? include("std.inc"); ?>
<? $title = "{$site_name} Preferences"; ?>
<? include("header.inc"); ?>

<?
$group_options = array(
   array("", "Home Phone", 1),
   array("", "Work Phone", 1),
   array("", "Cell Phone", 1),
   array("", "Street Address", 1),
   array("", "City", 1),
   array("", "State", 1),
   array("", "Postal Code", 1),
   array("", "Country", 1),
   array("edit", "Textarea Width", 1),
   array("edit", "Textarea Height", 1),
   );

function user_basic_form($u)
{
   $form_action = "index.php?action=user_basic_submit";
   printf("<form method=post action=\"%s\">\n", $form_action);
   
   // Regular user info
   // UID, username, passwd, realname
   blurb("Basic User Info");
   printf("<table>\n");

   //printf("<tr><td align=right>%s</td>\n", "User Name");
   //printf("<td>\n<input type=text name=\"setvar:%s\" value=\"%s\">\n",
   //  "username", $u->username);
   //echo "</td></tr>\n";
   
   printf("<tr><td align=right>%s</td>\n", "Real Name");
   printf("<td>\n<input type=text name=\"setvar:%s\" value=\"%s\">\n",
	  "realname", $u->realname);
   echo "</td></tr>\n";
   
   //printf("<tr><td align=right>%s</td>\n", "Email");
   //printf("<td>\n<input type=text name=\"setvar:%s\" value=\"%s\">\n",
   //  "email", $u->email);
   //echo "</td></tr>\n";
   
   printf("<tr><td align=right>%s</td>\n", "Password");
   printf("<td>\n<input type=password name=\"setvar:%s\" value=\"%s\">\n",
	  "password", "");
   echo "</td></tr>\n";
   
   printf("<tr><td align=right>%s</td>\n", "Password (Again)");
   printf("<td>\n<input type=password name=\"setvar:%s\" value=\"%s\">\n",
	  "password2", "");
   echo "</td></tr>\n";
   
   echo "<tr><td align=right>";
   echo "Coming soon:</td><td>";
   echo "Change email address";
   echo "</td></tr>\n";

   printf("</table>\n");

   echo "<input type=submit value=\"Go\">\n";
   echo "<input type=reset value=\"Nevermind...\">\n";
   
   echo "</form>\n";
	 eb();
}

function user_basic_submit($u)
{
   // Values to set: "setvar:" username, realname, password, password2
   global $HTTP_POST_VARS;

   trans_post_vars();
   
   $db = connect_db();

   if(! $u) return;
   
   $value = $HTTP_POST_VARS["setvar:username"];
   if($value  and  ($value != $u->username)) { $u->username = $value; }

   $value = $HTTP_POST_VARS["setvar:realname"];
   if($value  and  ($value != $u->realname)) { $u->realname = $value; }

   $value = $HTTP_POST_VARS["setvar:email"];
   if($value  and  ($value != $u->email)) { $u->email = $value; }
   
   $pass1 = $HTTP_POST_VARS["setvar:password"];
   $pass2 = $HTTP_POST_VARS["setvar:password2"];
   $value = $pass1;
   //$value = "password('$pass1')";
   if($pass1  and  ($pass1 == $pass2)) { $u->passwd = $pass1; }

   $u->save();
   printf("Values have been updated.<br>\n");

   view_user($u);
}

function user_group_form($u)
{
  blurb("Groups");
  echo "<a href=\"access.php\">Request more access</a> (membership in groups)\n";
  eb();
}

function user_hash_form($u)
{
   global $SCRIPT_NAME;
   global $group_options;

   blurb("Misc User Options");

   //foreach ($u->groups as $g)
   //   { echo  "Group: $g<br>\n"; }
   
   $form_action = "{$SCRIPT_NAME}?action=user_hash_submit";
   printf("<form method=post action=\"%s\">\n", $form_action);

   // load existing options  (assume it's already done)
   // merge options based on user's groups
   foreach ($group_options as $goe)
   {
      $g = $goe[0];
      $o = $goe[1];
      $e = $goe[2];
      if ($g == ""   ||   in_array($g, $u->groups))
      {
	 $found = 0;
	 foreach ($u->attribs as $a)
	    { if ($a->key == $o) {$found = 1;}}
	 if (! $found)
	 {
	    //echo "Adding option {$o}.<br>\n";
	    array_push($u->attribs, user_attribute($o, "", $e));
	 }
      }
   }
   // remove read-only options

   // User hash options
   echo "<table>\n";
   foreach ($u->attribs as $a)
   {
      $name = $a->key;
      $value = $a->value;
      $edit = $a->edit;

      if (! $edit) continue;
      
      //printf("edit: %s<br>\n", $edit);
      
      $on = "";
      if($edit) { $on = "checked"; }
      
      echo "<tr>\n";
      //printf("<td><input type=checkbox name=\"editvar:%s\" %s>Editable</td>\n",
      //     trans_var($name), $on);
      printf("<td align=right>%s</td>\n", $name);
      printf("<td><input type=text name=\"setvar:%s\" value=\"%s\">" .
	     "</td>\n",
	     trans_var($name), $value);
      //printf("<td><input type=checkbox name=\"delvar:%s\">Delete</td></tr>\n",
      //     trans_var($name));
   }
   //echo "<tr>\n";
   //printf("<td><input type=checkbox name=\"addvar:edit\">Editable</td>\n");
   //printf("<td align=right><input type=text name=\"addvar:name\"></td>\n");
   //printf("<td><input type=text name=\"addvar:value\"></td>\n");
   //printf("<td><i><b>Add New...</b></i></td></tr>\n");
   echo "</table>\n";

   echo "<input type=submit value=\"Go\">\n";
   echo "<input type=reset value=\"Nevermind...\">\n";
   
   echo "</form>\n";
   eb();
}

function user_hash_submit($u)
{
   global $HTTP_POST_VARS;

   $db = connect_db();
   
   if(! $u) return;

   trans_post_vars();
   
   // Get a complete list of hash variables
   $postlist = post_var_search("setvar:");
   $hashlist = array();
   foreach($postlist as $key => $value)
   {
      $a = user_attribute($key, $value, 1);
      $hashlist[$key] = $a;
   }


   foreach ($hashlist as $foo => $a)
   {
      $key = $a->key;
      $value = $a->value;
      $edit = $a->edit;

      //printf("a: %s => %s (%s)<br>\n",
      //	     $key, $value, $edit);
      
      if (! $value)
      {
	 // Unset the sucker.
	 if(array_has_key($u->attribs, $key))
	    printf("Delete $key...<br>\n");
	 $u->attribs[$key] = "";
	 
	 //$query = "delete from $table where UID = $uid " .
	 //   "and name = '$key';";
	 //printf("$query<br>\n");
	 //mysql_query($query);
      }
      else
      {
	 printf("Update %s...<br>\n", $key);
	 $u->attribs[$key] = $a;
	 //$query = sprintf("update %s set value = '%s' " .
	 //		  "where UID = %s " .
	 //		  "and name = '%s';",
	 //		  $table, $value, $uid, $key);
	 //printf("%s<br>\n", $query);
	 //mysql_query($query);

	 //$query = sprintf("update %s set edit = %s " .
	 //		  "where UID = %s " .
	 //		  "and name = '%s';",
	 //		  $table, $edit, $uid, $key);
	 //printf("%s<br>\n", $query);
	 //mysql_query($query);
      }

   }

   $u->save_attribs();

   printf("Values have been updated.<br>\n");


   view_user($u);
}

function view_user($auth_user)
{
   // TODO: basic user info form (email)
   // TODO: basic user info form submit function
   user_basic_form($auth_user);
   user_group_form($auth_user);
   user_hash_form($auth_user);
   
   // TODO: misc option edit form submit function
}

function user_page($auth_user)
{
   global $action;

   if(!$action)
   {
      view_user($auth_user);
   }
   else if($action == "user_basic_submit")
   {
      user_basic_submit($auth_user);
   }
   else if($action == "user_hash_submit")
   {
      user_hash_submit($auth_user);
   }

   //echo "<br>This page is not fully implemented yet.\n";
}

check_login();
?>

<? include("footer.inc"); ?>
